# This script exports the current HBM, bones and skin entities, to obj files.
# Each entity is exported in a seperate file
#
# arguments: 
# /path/to/mesh/directory

# author: Thomas Lemaire, Matthieu Mear, date: 2017


import sys
import exceptions
import os.path
import json

import piper.hbm
import piper.app
import piper.anatomyDB

def writeObj(fem, entities, objDirPath):
    nodeIdToObjIndex = dict()
    objIndexToNodeId = dict()
    for entity in entities:
        #allNodeIds = set()
        nodeIdList = entity.getEnvelopNodes(fem)
        elem2DIdList = entity.getEnvelopElements(model.fem())

        objFilePath = os.path.join(objDirPath, entity.name()+".obj")
        with open(objFilePath, 'w') as objFile:
            piper.app.logInfo("Writting obj file {0} ...".format(objFilePath))
            objFile.write("# File generated by the PIPER application\n")
            currentIndex = 1 # obj convention starts at 1
            for nodeId in nodeIdList:
                nodeIdToObjIndex[nodeId] = currentIndex
                objIndexToNodeId[currentIndex] = nodeId
                coord = fem.getNode(nodeId).get().flatten()
                objFile.write("v {0} {1} {2}\n".format(coord[0], coord[1], coord[2]))
                currentIndex+=1
            for elemId in elem2DIdList:
                # If it's a triangle face
                if len(elemId) == 3:
                    objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[elemId[0]], nodeIdToObjIndex[elemId[1]], nodeIdToObjIndex[elemId[2]]))
                # If it's a quad face
                elif len(elemId) == 4: 
                    objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[elemId[0]], nodeIdToObjIndex[elemId[1]], nodeIdToObjIndex[elemId[2]]))
                    objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[elemId[0]], nodeIdToObjIndex[elemId[2]], nodeIdToObjIndex[elemId[3]]))

model = piper.app.Context.instance().project().model()

# if the model is empty, we can do nothing
if model.empty():
    piper.app.logWarning("Model is empty")
elif 2 != len(sys.argv) :
    raise RuntimeError("Invalid arguments")
else :
    # create destination directory if necessary
    if not os.path.exists(sys.argv[1]):
        os.makedirs(sys.argv[1])
    metadata = model.metadata()
    entitiesToExport = []
    for name,entity in metadata.entities().iteritems() :
        if piper.anatomyDB.isEntitySubClassOf(name, "Bone") or piper.anatomyDB.isEntitySubClassOf(name, "Skin"): #check if entity is bone or skin
            entitiesToExport.append(entity)
    writeObj(model.fem(), entitiesToExport, sys.argv[1])
    
    